
#version 330 core

uniform sampler2D dif_texture;
uniform vec2 screen_dimension;

in  vec2 ex_coord;
out vec4 out_color;

void main(void)
{
	/*int sizeX = 7;
	int sizeY = 7;
	int i = 0;
	int j = 0;
	int posx = 0;
	int posy = 0;

	// filter matrix.
	float arr[49] = float[]( 0,     0,     1,     1,     1,     0,     0,
							0,     1,     1,     1,     1,     1,     0,
							1,     1,     1,     1,     1,     1,     1,
							1,     1,     1,     1,     1,     1,     1,
							1,     1,     1,     1,     1,     1,     1,
							0,     1,     1,     1,     1,     1,     0,
							0,     0,     1,     1,     1,     0,     0);

	
	vec4 pid = texelFetch(dif_texture,ivec2(ex_coord),0);
	float sum = 0;
	for(i = 0;i<sizeX;i++){
		posx = i-3;
		for(j = 0;j<sizeY;j++){
			posy = j-3;
			vec4 c = texture(dif_texture, vec2(pid.x+posx,pid.y+posy));
			 Take red part of image as maximum.
			if(arr[i*sizeX+j] == 1){
				if(max<c.r){
					sum += c.r;
				}
			}
		}
	}
	sum = min(1,sum);*/

	vec4 sum = vec4(0.0,0.0,0.0,0.0);

	int i;
	float xdif = 1.0 / screen_dimension.x;
	float ydif = 1.0 / screen_dimension.y;
	sum += texture(dif_texture, vec2(ex_coord.x-2*xdif, ex_coord.y-ydif));
	sum += texture(dif_texture, vec2(ex_coord.x-2*xdif, ex_coord.y));
	sum += texture(dif_texture, vec2(ex_coord.x-2*xdif, ex_coord.y+ydif));
	sum += texture(dif_texture, vec2(ex_coord.x-xdif, ex_coord.y-2*ydif));
	//sum += texture(dif_texture, vec2(ex_coord.x-xdif, ex_coord.y-ydif));
	//sum += texture(dif_texture, vec2(ex_coord.x-xdif, ex_coord.y));
	//sum += texture(dif_texture, vec2(ex_coord.x-xdif, ex_coord.y+ydif));
	sum += texture(dif_texture, vec2(ex_coord.x-xdif, ex_coord.y+2*ydif));
	sum += texture(dif_texture, vec2(ex_coord.x, ex_coord.y-2*ydif));
	//sum += texture(dif_texture, vec2(ex_coord.x, ex_coord.y-ydif));
	//sum += texture(dif_texture, vec2(ex_coord.x, ex_coord.y));
	//sum += texture(dif_texture, vec2(ex_coord.x, ex_coord.y+ydif));
	sum += texture(dif_texture, vec2(ex_coord.x, ex_coord.y+2*ydif));
	sum += texture(dif_texture, vec2(ex_coord.x+xdif, ex_coord.y-2*ydif));
	//sum += texture(dif_texture, vec2(ex_coord.x+xdif, ex_coord.y-ydif));
	//sum += texture(dif_texture, vec2(ex_coord.x+xdif, ex_coord.y));
	//sum += texture(dif_texture, vec2(ex_coord.x+xdif, ex_coord.y+ydif));
	sum += texture(dif_texture, vec2(ex_coord.x+xdif, ex_coord.y+2*ydif));
	sum += texture(dif_texture, vec2(ex_coord.x+2*xdif, ex_coord.y-ydif));
	sum += texture(dif_texture, vec2(ex_coord.x+2*xdif, ex_coord.y));
	sum += texture(dif_texture, vec2(ex_coord.x+2*xdif, ex_coord.y+ydif));
	
	sum.r = min(1,sum.r);
	vec4 middle = texture(dif_texture, vec2(ex_coord.x, ex_coord.y));
	sum.r -= middle.r;
	sum.g = sum.r;
	sum.b = sum.r;
	sum.a = sum.r;

	out_color = sum;
}