#version 330 core

layout(points) in;

layout(line_strip, max_vertices = 5) out;

uniform mat4 perspective;

in vec4 mvNormal[1];
in vec4 mvTangent[1];
in vec4 mvBitangent[1];
in vec4 mvPosition[1];
flat out vec3 color;

void main(void)
{
	vec4 n = perspective * vec4(mvPosition[0].xyz + 1.0*normalize(mvNormal[0].xyz),1.0);
	vec4 t = perspective * vec4(mvPosition[0].xyz + 1.0*normalize(mvTangent[0].xyz),1.0);
	vec4 b = perspective * vec4(mvPosition[0].xyz + 1.0*normalize(mvBitangent[0].xyz),1.0);

	gl_Position = n;
	color = vec3(0.0,0.0,0.0);
	EmitVertex();
	gl_Position = gl_in[0].gl_Position;
	color = vec3(0.0,1.0,0.0);
	EmitVertex();
	gl_Position = b;
	color = vec3(1.0,0.0,0.0);
	EmitVertex();
	gl_Position = gl_in[0].gl_Position;
	color = vec3(1.0,0.0,0.0);
	EmitVertex();
	gl_Position = t;
	color = vec3(0.0,0.0,1.0);
	EmitVertex();
	EndPrimitive();
}